#
#    Licensed under the Apache License, Version 2.0 (the "License"); you may
#    not use this file except in compliance with the License. You may obtain
#    a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
#    WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
#    License for the specific language governing permissions and limitations
#    under the License.

from ceilometerclient import client as cc

from heat.tests import common
from heat.tests import utils


class CeilometerClientPluginTest(common.HeatTestCase):

    def test_create(self):
        self.patchobject(cc.SessionClient, 'request')
        context = utils.dummy_context()
        plugin = context.clients.client_plugin('ceilometer')
        client = plugin.client()
        self.assertIsNotNone(client.alarms)
